package com.school.project.controller;

import com.school.project.dto.teacher.AddAssessmentDTO;
import com.school.project.dto.teacher.AddSectionDTO;
import com.school.project.dto.teacher.TeacherViewCoursesDTO;
import com.school.project.dto.teacher.TeacherViewDataDTO;
import com.school.project.service.teacher.TeacherServiceImpl;
import com.school.project.service.teacher.UploadMarksServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.security.Principal;

@RestController
@RequestMapping("/teacher")
public class TeacherController {

    @Autowired
    TeacherServiceImpl teacherService;

    @Autowired
    UploadMarksServiceImpl uploadMarksService;


    @GetMapping("")
    public TeacherViewDataDTO getTeacherData(Principal principal) {
        return teacherService.getTeacherData(principal.getName());
    }

    @GetMapping("/course")
    public TeacherViewCoursesDTO getTeacherCourses(Principal principal) {
        return teacherService.getTeacherCourses(principal.getName());
    }

    @PostMapping("/upload/marks")
    public void addAssessment(@RequestBody AddAssessmentDTO addAssessmentDTO){
        uploadMarksService.setAssessment(addAssessmentDTO).getAssessmentId();
    }

    @PostMapping("/upload/marks/section")
    public void addSectionInAssessment(@RequestBody AddSectionDTO addSectionDTO) {
        uploadMarksService.setSection(addSectionDTO);
    }
}
