package com.school.project.model.marks;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.sun.istack.NotNull;
import lombok.Getter;
import lombok.Setter;

import javax.persistence.*;

@Getter
@Setter
@Entity
@Table(name = "section")
public class Section {

    @Id
    @GeneratedValue(strategy = GenerationType.SEQUENCE)
    @Column(name = "section_id")
    private Long sectionId;

    @NotNull
    @Column(name = "total_marks")
    private Long totalMarks;

    @NotNull
    @Column(name = "total_weightage")
    private Long totalWeightage;

    @ManyToOne(fetch = FetchType.LAZY)
    @JoinTable(name = "assessment_sections",
            joinColumns = {@JoinColumn(name = "assessment_id",insertable = false,updatable = false)},
            inverseJoinColumns = {@JoinColumn(name = "section_id",insertable = false,updatable = false)})
    private Assessment assessment;

    @OneToOne(mappedBy = "section",cascade = CascadeType.ALL,fetch = FetchType.LAZY)
    @JsonIgnore
    private StudentMarks studentMarks;
}


