package com.school.project.service.teacher;

import com.school.project.dto.teacher.AddAssessmentDTO;
import com.school.project.dto.teacher.AddSectionDTO;
import com.school.project.mapper.SectionToListOfSectionMapper;
import com.school.project.model.marks.Assessment;
import com.school.project.model.marks.Section;
import com.school.project.repository.CourseRepository;
import com.school.project.repository.marks.AssessmentRepository;
import com.school.project.repository.marks.AssessmentTypeRepository;
import com.school.project.repository.marks.SectionRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;

@Service
public class UploadMarksServiceImpl implements UploadMarksService {

    @Autowired
    CourseRepository courseRepository;
    @Autowired
    AssessmentTypeRepository assessmentTypeRepository;

    @Autowired
    AssessmentRepository assessmentRepository;

    @Autowired
    SectionRepository sectionRepository;

    @Autowired
    SectionToListOfSectionMapper mapper;

    @Override
    @Transactional
    public Assessment setAssessment(AddAssessmentDTO assessmentDTO) {
        Assessment assessment = new Assessment();

        assessment.setAssessmentType(assessmentTypeRepository.findByAssessmentTypeName(
                assessmentDTO.getAssessment()));

        assessment.setCourse(courseRepository.findByCourseCode(
                assessmentDTO.getCourseCode()));

        return assessmentRepository.save(assessment);
    }

    @Override
    @Transactional
    @Modifying
    public Section setSection(AddSectionDTO sectionDTO) {
        Section section = new Section();

        section.setAssessment(assessmentRepository.findByAssessmentId(sectionDTO.getAssessmentId()));
        section.setTotalMarks(sectionDTO.getTotalMarks());
        section.setTotalWeightage(sectionDTO.getTotalWeightage());

        section = sectionRepository.save(section);

        Assessment assessment = assessmentRepository.findByAssessmentId(sectionDTO.getAssessmentId());
        assessment.setSection(mapper.modelToList(section));

        return section;
    }

}
